
import java.applet.*;
import java.awt.*;
import java.lang.*;


         
public class Interceptor
{

   public double[] base_position = new double[3];
   public double[] return_position = new double[3];
   public double[] current_position = new double[3];

   int i;
   int cnt=1;
   FireControl smain;
   double Distance ;
   

  Interceptor(FireControl smain, double x, double y, double z)
    { 
        this.smain = smain;
        base_position[0] = x;
        base_position[1] = y;
        base_position[2] = z;

        current_position[0] = x;
        current_position[1] = y;
        current_position[2] = z;

      }
 


   public void TraceTarget()
      {   

	double unit = 1.609* 880 /60;
/*	double unit = 880 /60; miles */

   	double rate ;           
	GetDistance(smain.ac_cur_location[0][0],smain.ac_cur_location[0][1],
	smain.ac_cur_location[0][2],current_position[0],current_position[1],
	current_position[2]);

	rate = unit /Distance;
	if (rate >1) rate = 0.1;
	System.out.println("rate = "+ rate);

        /* x coordinate  */
        current_position[0] = current_position[0] +
                             ((smain.ac_cur_location[0][0] - current_position[0]) * rate );
        /* y coordiante  */
        current_position[1] = current_position[1] +
                             ((smain.ac_cur_location[0][1] - current_position[1]) * rate);

        /* z coordinate  */
        current_position[2] = current_position[2] +
                             ((smain.ac_cur_location[0][2] - current_position[2]) * rate );

     

        } /* end TraceTarget */


private void GetDistance(double x, double y, double z, double l, double r, double h)
{
	double radian = Math.PI/180;
	double ax, ay, az, ix, iy, iz;

	ax = x  * radian; 
	ay = y  * radian;
	az = z; 
	
	ix = l * radian;
	iy = r * radian;
	iz = h;
    Transform (ax, ay, az, ix, iy, iz);

	System.out.println("ax="+x+" ay="+y+" az="+z+" rx="+l+" ry="+r+
     " rz="+h+" R="+Distance);

	
}

       
private void Transform (double x, double y,double z,double l,double r,
                double h)
        {
        double F= 1/298.26;
        double Re= 6378.135;
        double eexp, u, Rf, Zita, Eita, Tau , Xq, Yq, Zq,
		AZita, AEita, ATau;
        double[][] A = new double[3][3];
        double[] B = new double[3];
        int j;

/*
        eexp = 2*F - F*F;

        u = Math.atan(1/Math.pow((1-F), 2) * Math.tan(r));

        Rf = Re * Math.sqrt(1 - eexp) / Math.sqrt(1 - eexp *
                Math.cos(r) * Math.cos(r));

*/
        Zita = (Re * Math.cos(r) + h * Math.cos(r)) * Math.cos(l);
        Eita = (Re * Math.cos(r) + h * Math.cos(r)) * Math.sin(l);
        Tau  = Re * Math.sin(r) + h * Math.sin(r);       
	    AZita = (Re * Math.cos(y) + z * Math.cos(y)) * Math.cos(x);
        AEita = (Re * Math.cos(y) + z * Math.cos(y)) * Math.sin(x);
        ATau  = Re * Math.sin(y) + z * Math.sin(y);


        A [0][0] = -1 * Math.sin(l);
        A [0][1] = Math.cos(l);
        A [0][2] = 0;
        A [1][0] = -1 * Math.sin(r) * Math.cos(l);
        A [1][1] = -1 * Math.sin(r) * Math.sin(l);
        A [1][2] = Math.cos(r);
        A [2][0] = Math.cos(r) * Math.cos(l);
        A [2][1] = Math.cos(r) * Math.sin(l);
        A [2][2] = Math.sin(r);

/*
        A [1][0] = -1 * Math.sin(u) * Math.cos(l);
        A [1][1] = -1 * Math.sin(u) * Math.sin(l);
        A [1][2] = Math.cos(u);
        A [2][0] = Math.cos(u) * Math.cos(l);
        A [2][1] = Math.cos(u) * Math.sin(l);
        A [2][2] = Math.sin(u);
*/

        B[0] = AZita - Zita;
        B[1] = AEita - Eita ;
        B[2] = ATau - Tau ;

        Xq = Yq = Zq = 0;


        for (j = 0; j< 3; j++)
        {

                Xq = Xq + A[0][j] * B[j];
                Yq = Yq + A[1][j] * B[j];
                Zq = Zq + A[2][j] * B[j];

        }


        Distance = Math.sqrt(Xq*Xq + Yq*Yq + Zq*Zq);
   
	} 



    public void get_return_position()
      {   
              
        /* x coordinate  */
        return_position[0] = current_position[0];

        /* y coordiante  */
        return_position[1] = current_position[1];

        /* z coordinate  */
        return_position[2] = current_position[2];

        } /* end get_return_position */



 

   public void ReturnToBase()
      {
           

       if ( (current_position[0] == base_position[0]) || (cnt == 10) )
          {  current_position[0] = base_position[0];
             current_position[1] = base_position[1];

             cnt = 1;
           
           }
    
       else
         {             
   
            current_position[0] = current_position[0] +
                                 (( base_position[0] - return_position[0]) * 0.1 );
   
            current_position[1] = current_position[1] +
                                 ((base_position[1] - return_position[1] ) * 0.1 );

   
            current_position[2] = current_position[2] +
                                (( base_position[2] - return_position[2] ) * 0.1 );
           }

        cnt++;

        }/* end ReturnToBase */
      
 }





