import java.applet.*;
import java.awt.*;
import java.lang.*;

public class RFrame extends Frame
{
    Panel    leftpanel,rightpanel,leftsubpanel,rightsubpanel;

    TextField  radarname, start_x, start_y, start_z, maxr,mine;
    Button   startbutton,showbutton;
    TextArea   showarea;
    Label	path;

    String name, xx,yy,zz;
    public static double lon, lat, hit;
    public static double Range, Azimuth, Elevation;
    double  l, r, h, radian = Math.PI/180, ax, ay, az;

    RFrame(int number, double lx,  double ly, double hi) 
     { 

				lon = lx;
				lat = ly;
				hit = hi;

				l = lon * radian;
				r = lat * radian;
				h = hit;
 		

        
    }


public void GetRAE(double x, double y, double z)
{
	ax = x  * radian; 
	ay = y  * radian;
	az = z; 
    Transform (ax, ay, az, l, r, h);
/*
	System.out.println("ax="+x+" ay="+y+" az="+z+" rx="+lon+" ry="+lat+
     " rz="+hit+" R="+Range+" A="+Azimuth+" E="+Elevation);
*/
	
}

       
private void Transform (double x, double y,double z,double l,double r,
                double h)
        {
        double F= 1/298.26;
        double Re= 6378.135;
        double eexp, u, Rf, Zita, Eita, Tau , Xq, Yq, Zq,
		AZita, AEita, ATau;
        double[][] A = new double[3][3];
        double[] B = new double[3];
        int j;

/*
        eexp = 2*F - F*F;

        u = Math.atan(1/Math.pow((1-F), 2) * Math.tan(r));

        Rf = Re * Math.sqrt(1 - eexp) / Math.sqrt(1 - eexp *
                Math.cos(r) * Math.cos(r));

*/
        Zita = (Re * Math.cos(r) + h * Math.cos(r)) * Math.cos(l);
        Eita = (Re * Math.cos(r) + h * Math.cos(r)) * Math.sin(l);
        Tau  = Re * Math.sin(r) + h * Math.sin(r);       
	    AZita = (Re * Math.cos(y) + z * Math.cos(y)) * Math.cos(x);
        AEita = (Re * Math.cos(y) + z * Math.cos(y)) * Math.sin(x);
        ATau  = Re * Math.sin(y) + z * Math.sin(y);


        A [0][0] = -1 * Math.sin(l);
        A [0][1] = Math.cos(l);
        A [0][2] = 0;
        A [1][0] = -1 * Math.sin(r) * Math.cos(l);
        A [1][1] = -1 * Math.sin(r) * Math.sin(l);
        A [1][2] = Math.cos(r);
        A [2][0] = Math.cos(r) * Math.cos(l);
        A [2][1] = Math.cos(r) * Math.sin(l);
        A [2][2] = Math.sin(r);

/*
        A [1][0] = -1 * Math.sin(u) * Math.cos(l);
        A [1][1] = -1 * Math.sin(u) * Math.sin(l);
        A [1][2] = Math.cos(u);
        A [2][0] = Math.cos(u) * Math.cos(l);
        A [2][1] = Math.cos(u) * Math.sin(l);
        A [2][2] = Math.sin(u);
*/

        B[0] = AZita - Zita;
        B[1] = AEita - Eita ;
        B[2] = ATau - Tau ;

        Xq = Yq = Zq = 0;


        for (j = 0; j< 3; j++)
        {

                Xq = Xq + A[0][j] * B[j];
                Yq = Yq + A[1][j] * B[j];
                Zq = Zq + A[2][j] * B[j];

        }


        Range = Math.sqrt(Xq*Xq + Yq*Yq + Zq*Zq);
        Azimuth = Math.atan(Xq/Yq);
        Elevation = Math.asin(Zq/Range);


   
	} 


}



