/*
 * Client_Servlet3.java --
 *
 * ver1.0 : 23rd, March, 1997
 *          * plugged in servlets to call Local_Client object
 *          * called by Server_Pll class through URL
 *          * Limitation : test only on SOLARIS
 *                         No way to get parameters from server servlet
 *                         -- Local_Client hardcods the server name & port
 * 
 *
 * ver1.1 : 30th,March,1997
 *          * test on IBM machines 
 *          * test paramters passing from master servlet
 *
 * ver1.5 : 10th,Jan.,1998
 *          * stop all application and destroy servlet as required
 */

import java.io.*;
import javax.servlet.*;

public class Client_Servlet3 extends GenericServlet { 

 Local_Client3 clientCVM = null; // modified by IK Ra 07/15/98
    // LACS clientCVM = null;

    public void service(ServletRequest req, ServletResponse res)
	throws ServletException, IOException
    {
	String server_name = req.getParameter("server_name");
	String port = req.getParameter("port");
        String DB_driver = req.getParameter("DB_driver");
        String user_ID = req.getParameter("user_ID");
        String app_ID = req.getParameter("app_ID");
        String task_id = req.getParameter("task_id");
        String DVM_port = req.getParameter("DVM_port");
        String DB_IP = req.getParameter("DB_IP");
        String DB_port = req.getParameter("DB_port");

        System.out.println("====Local Servlet for task " + task_id + " is invoked=====");
        System.out.println("user_ID got in Client_Servlet : " + user_ID + "    app_ID : " + app_ID +  " DVM_port: " + DVM_port + " DB_IP:" + DB_IP + " DB_port:" + DB_port);
        System.out.println("From " + java.net.InetAddress.getLocalHost().toString());
        System.out.println("==========================================");

        res.setContentType("text/html");

        PrintWriter out = new PrintWriter(res.getOutputStream());
        out.println("<HEAD><TITLE> clientCVM works </TITLE></HEAD><BODY>");

	out.println("</BODY>");
	out.flush();
     
        //------ call Local_Client object -------
         clientCVM = new Local_Client3(server_name,port,user_ID,app_ID,task_id,DVM_port,DB_IP,DB_port); // by IK Ra 07/15/98
        // clientCVM = new LACS(server_name,port,user_ID,app_ID,task_id,DVM_port,DB_IP,DB_port);
        System.out.println("go into work()..");

        clientCVM.work();

        System.out.println("\n Hello,client servlet for task " + task_id + " has been completed!");
	
        System.out.println("Bye!");
    }

    public String getServletInfo() {
        return "client servlet";
    }

}
